#ifndef DMBOTOP_H_INCLUDED
#define DMBOTOP_H_INCLUDED

#include <windows.h>
#include <commctrl.h>
#include <richedit.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include "DynBuffer.h"
#include "List.h"
#include "UserFlags.h"
#include "CDKeyDecode.h"
#include "CheckRevision.h"
#include "resource.h"

#define DATA_PENDING_TCP        WM_USER + 1

#define VERBYTE_STARCRAFT 0xc5

#define BLACK      0x000000
#define WHITE      0xffffff
#define RED        0x0000ff
#define GREEN      0x00ff00
#define BLUE       0xff0000
#define LIGHTBLUE  0xffff00
#define GRAY       0xb4b4b4
#define YELLOW     0x33ffff

#define WINDOWS_VERSION_NT    4
#define WINDOWS_VERSION_98    14
#define WINDOWS_VERSION_ME    94
#define WINDOWS_VERSION_2K    5
#define WINDOWS_VERSION_XP    10
#define WINDOWS_VERSION_NET   20

void Send(SOCKET sckBNCS, char *lpszFmt, ...);
void ParseCommand(SOCKET sckBNCS, const char *lpszUser, const char *lpszCommand);
void ProcessCustomCommand(SOCKET sckBNCS, const char *lpszUser, const char *lpszCommand);

bool IsSafe(const char *szUser);
bool IsFriend(const char *szUser);
unsigned long Find(const char *szUser);
unsigned long FindEx(const char *szUser, char *szMatches);
void WildCardBan(SOCKET sckBNCS, const char *szWild, const char *szMsg);
void WildCardKick(SOCKET sckBNCS, const char *szWild, const char *szMsg);
void UpdateChannel();
int wildcmp(char *wild, char *string);

void LoadDB();
void WriteDB();

unsigned long GetProcessorClockSpeed(ULARGE_INTEGER &Hz);

DynBuffer dBuf;
SOCKET sckBNCS;

char szUsername[32], szPassword[256], szServer[256], szCDKey[32], szHomeChannel[128], szIdle[256], szTrigger[32];
char szCurrentChannel[128];

List<char *> UserList;
List<char *> ChanList;
List<char *> Queue;
List<unsigned long> UserAttributes;
List<char *> CCList;
List<char *> CCFormats;
List<char *> Words;
List<char *> Players;
List<int> PlayerScores;

HWND hMainDlg, hStatus;
HINSTANCE hDlgInst;

unsigned long dwSeed;

HANDLE hRecvEvent;
unsigned long dwFloodTimer, dwIdleTimer, dwUptime, dwWordGameTimer;
bool bLastReply;

bool bProtect, bOperator, bWordGame, bGuessed;

char szUniqueName[32], szDesignated[32];

ULARGE_INTEGER uProcessorSpeed;

char *pszCurrentWord, *pszCurrentRevealed;

#endif