#ifndef GLOBALS_H_INCLUDED
#define GLOBALS_H_INCLUDED

#include <stdio.h>
#include "DynBuffer.h"
#include "List.h"
#include "UserFlags.h"

#define WINDOWS_VERSION_NT    4
#define WINDOWS_VERSION_98    14
#define WINDOWS_VERSION_ME    94
#define WINDOWS_VERSION_2K    5
#define WINDOWS_VERSION_XP    10
#define WINDOWS_VERSION_NET   20

void Send(char *lpszFmt, ...);
void ParseCommand(const char *lpszUser, const char *lpszCommand);
void ProcessCustomCommand(const char *lpszUser, const char *lpszCommand);

bool IsSafe(const char *szUser);
bool IsFriend(const char *szUser);
unsigned long Find(const char *szUser);
unsigned long FindEx(const char *szUser, char *szMatches);
void WildCardBan(const char *szWild, const char *szMsg);
void WildCardKick(const char *szWild, const char *szMsg);
void UpdateChannel();
int wildcmp(char *wild, char *string);

void LoadConfig();
void WriteConfig();
void LoadDB();
void WriteDB();
void LoadCommands();
void WriteCommands();

unsigned long GetProcessorClockSpeed(ULARGE_INTEGER &Hz);

DynBuffer dBuf;
SOCKET sckBNCS;

char szUsername[32], szPassword[256], szServer[256], szCDKey[32], szHomeChannel[128], szIdle[256], szTrigger[32];
char szCurrentChannel[128];

List<char *> UserList;
List<unsigned long> UserAttributes;
List<char *> ChanList;
List<char *> CCList;
List<char *> CCFormats;

HWND hMainDlg, hStatus;
HINSTANCE hDlgInst;

unsigned long dwSeed;

HANDLE hRecvEvent;
unsigned long dwFloodTimer, dwIdleTimer, dwUptime, dwWordGameTimer;
bool bLastReply;

bool bProtect, bOperator, bWordGame, bGuessed;

char szUniqueName[32], szDesignated[32];

ULARGE_INTEGER uProcessorSpeed;

char *pszCurrentWord, *pszCurrentRevealed;

#endif